unit MAIN;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, XPMenu, DB, ADODB, ElAES, Math,
//HU}uses SBKS椸
  about, CustU, AddressU, ADDSU, BKTU, WRTU, BKCLASSU, BKCOSTU,
  POSU, POSCLOSEU, NEWBKU, BKDAYU, CUSTLVU;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    MN1: TMenuItem;
    MN11: TMenuItem;
    MN12: TMenuItem;
    MN4: TMenuItem;
    MN41: TMenuItem;
    MN42: TMenuItem;
    MN44: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowMinimizeAll1: TWindowMinimizeAll;
    WindowTileVertical1: TWindowTileVertical;
    MN43: TMenuItem;
    ImageList1: TImageList;
    XPMenu1: TXPMenu;
    SBKSDB: TADOConnection;
    QrySEQ: TADOQuery;
    QRYCMD: TADOQuery;
    procedure DoForm(fname: TClass);
    procedure FileExit1Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MN31Click(Sender: TObject);
    procedure MN12Click(Sender: TObject);
    procedure MN15Click(Sender: TObject);
    procedure MN32Click(Sender: TObject);
    procedure MN51Click(Sender: TObject);
    procedure MN11Click(Sender: TObject);
    function CkIDNum(idn: string): boolean;
    procedure MN13Click(Sender: TObject);
    procedure MN14Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure MN21Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
  private
    { Private declarations }
  public
    function GetCustSEQ: string;
    function GetWrtSEQ: string;
    { Public declarations }
  end;

var
  MainForm: TMainForm;

function StringToHex(S: string): string; forward;
function HexToString(S: string): string; forward;
function Encrypt(s1: string; skey: string): string;
function Decypt(s1: string; skey: string): string;

implementation

{$R *.dfm}


//o@̽s

function TMainForm.GetWrtSEQ: string;
begin
  QrySEQ.Close;
  QrySEQ.SQL.Clear;
  QrySEQ.SQL.Add('SELECT WRT_SEQ FROM WRT');
  QrySEQ.SQL.Add('ORDER BY WRT_SEQ');
  QrySEQ.Open;
  QrySEQ.Last;
  if QrySEQ.RecordCount = 0 then
    Result := '0'
  else
    Result := QrySEQ.FieldValues['WRT_SEQ'];
end;

//oϥΪ̽s

function TMainForm.GetCustSEQ: string;
begin
  QrySEQ.Close;
  QrySEQ.SQL.Clear;
  QrySEQ.SQL.Add('SELECT CUST_SEQ FROM CUST');
  QrySEQ.SQL.Add('ORDER BY CUST_SEQ');
  QrySEQ.Open;
  QrySEQ.Last;
  if QrySEQ.RecordCount = 0 then
    Result := '0'
  else
    Result := QrySEQ.FieldValues['CUST_SEQ'];
end;


//ҵ{

function TMainForm.CkIDNum(idn: string): boolean;
const LetterCode: array[0..25] of byte = (10, 11, 12, 13, 14, 15, 16, 17, 34, 18, 19, 20, 21, 22, 35, 23, 24, 25, 26, 27, 28, 29, 32, 30, 31, 33);
var cksum: integer;
  i: ShortInt;
{ *Note:   k͡ײĤGX1 (Yr᪺@)
           k͡ײĤGX2 (Yr᪺@) }
begin
  Result := false;
  if length(idn) <> 10 then Exit; //`
  i := Ord(UpCase(idn[1])) - 65; //ҭr...(oȦbLetterCodemBT{A~Z@Bp[v)
  if ((i < 0) or (i > 25)) then Exit;
  cksum := (LetterCode[i] div 10) + (9 * LetterCode[i] mod 10);
  for i := 1 to 8 do cksum := cksum + StrToInt(idn[i + 1]) * (9 - i); //Ʀr[v[`
  if (cksum + StrToInt(idn[10])) mod 10 = 0 then Result := true; //˽X(̫@X)GPcksumMQ10㰣
end;

//MDI CHILD Ƶ{

procedure TMainForm.DoForm(fname: TClass);
var ICont: Integer;
  Form: TForm;
begin
  Form := nil;
  if MainForm.MDIChildCount <> 0 then
  begin
    for ICont := 0 to MainForm.MDIChildCount - 1 do
      if MDIChildren[ICont].ClassName = fname.ClassName then
      begin
        Form := MDIChildren[ICONT];
        Form.BringToFront;
      end;
    if Form = nil then
    begin
      Form := TFormClass(fname).Create(Application);
    end;
  end
  else
    Form := TFormClass(pchar(fname)).Create(Application);
  Form.WindowState := wsMaximized;
end;

function StringToHex(S: string): string;
var
  i: integer;
begin
  Result := '';
  // Go throught every single characters, and convert them
  // to hexadecimal...
  for i := 1 to Length(S) do
    Result := Result + IntToHex(Ord(S[i]), 2);
end;

function HexToString(S: string): string;
var
  i: integer;
begin
  Result := '';

  // Go throught every single hexadecimal characters, and convert
  // them to ASCII characters...
  for i := 1 to Length(S) do
  begin
    // Only process chunk of 2 digit Hexadecimal...
    if ((i mod 2) = 1) then
      Result := Result + Chr(StrToInt('0x' + Copy(S, i, 2)));
  end;
end;

//sX禡
//s1:ǤJѼ,skey:sX_

function Encrypt(s1: string; skey: string): string;
var
  Source: TStringStream;
  Dest: TStringStream;
  Size: integer;
  Key: TAESKey128;
begin
  // Encryption
  Source := TStringStream.Create(s1);
  Dest := TStringStream.Create('');
  try
    // Save data to memory stream...
    Size := Source.Size;
    Dest.WriteBuffer(Size, SizeOf(Size));
    // Prepare key...
    FillChar(Key, SizeOf(Key), 0);
    Move(PChar(skey)^, Key, Min(SizeOf(Key), Length(skey)));
    // Start encryption...
    EncryptAESStreamECB(Source, 0, Key, Dest);
    // Display encrypted text using hexadecimals...
    Result := StringToHex(Dest.DataString);
  finally
    Source.Free;
    Dest.Free;
  end;
end;

//ѽX禡
//s1:ǤJѼ,skey:sX_

function Decypt(s1: string; skey: string): string;
var
  Source: TStringStream;
  Dest: TStringStream;
  Size: integer;
  Key: TAESKey128;
  EncryptedText: TStrings;
  S: string;
begin
  // Convert hexadecimal to a strings before decrypting...
  Source := TStringStream.Create(HexToString(s1));
  Dest := TStringStream.Create('');
  try
    // Start decryption...
    Size := Source.Size;
    Source.ReadBuffer(Size, SizeOf(Size));
    // Prepare key...
    FillChar(Key, SizeOf(Key), 0);
    Move(PChar(skey)^, Key, Min(SizeOf(Key), Length(skey)));
    // Decrypt now...
    DecryptAESStreamECB(Source, Source.Size - Source.Position, Key, Dest);
    // Display unencrypted text...
    Result := Dest.DataString;
  finally
    Source.Free;
    Dest.Free;
  end;
end;



procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  XPMenu1.Active := False;
  XPMenu1.Active := True;
end;

procedure TMainForm.MN31Click(Sender: TObject);
begin
//
end;

procedure TMainForm.MN12Click(Sender: TObject);
begin
  DoForm(TCustF);
end;

procedure TMainForm.MN15Click(Sender: TObject);
begin
  DoForm(TAddressF);
end;

procedure TMainForm.MN32Click(Sender: TObject);
begin
  with TADDSF.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.MN51Click(Sender: TObject);
begin
  with TAboutBox.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.MN11Click(Sender: TObject);
begin
  DoForm(TBKTF);
end;

procedure TMainForm.MN13Click(Sender: TObject);
begin
  with TWRTF.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.MN14Click(Sender: TObject);
begin
  DoForm(TBKCLASSF);
end;

procedure TMainForm.N4Click(Sender: TObject);
begin
  DoForm(TBKCOSTF);
end;



procedure TMainForm.MN21Click(Sender: TObject);
begin
  DoForm(TPOSF);
end;

procedure TMainForm.N8Click(Sender: TObject);
begin
  with TNEWBKF.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.N7Click(Sender: TObject);
begin
  with TBKDAYF.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.N6Click(Sender: TObject);
begin
  with TCustLVF.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

end.

